indexing
	description: "Project root class"

class
	TEST

create
	make

feature {NONE} -- Initialization

	make is
			-- Run application.
		local
			results : SYSTEM_ARRAY
		do
			store_objects
			results := retrieve_objects
		end

feature
	store_objects is
			-- Store PARALLELOGRAM objects in the database.		
		local
			par : PARALLELOGRAM
			db : IOBJECT_CONTAINER
			closed : BOOLEAN
		do
			db := {DB_4O_FACTORY}.open_file("test.yap");
			create par.make_with_4_vertices (make_vertices(4))
			db.set(par)
			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end

	retrieve_objects : SYSTEM_ARRAY is
			-- Retrieve the objects from the database.
		local
			predicate : PARALLELOGRAM_PREDICATE
			db : IOBJECT_CONTAINER
			results : IOBJECT_SET
			closed : BOOLEAN
		do
			db := {DB_4O_FACTORY}.open_file("test.yap")
			create predicate
			results := db.query (predicate)
			if (results.has_next) then
				Result := {SYSTEM_ARRAY}.create_instance(results.next.get_type, results.count)
				results.copy_to (Result, 0)
			end
			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end


feature {NONE}
	make_vertices(count : INTEGER) : ARRAY[POINT] is
			-- Returns an ARRAY of POINT instances with the length of count.
		require
			count_positive : count > 0
		local
			i : INTEGER
			random : SYSTEM_RANDOM
			p : POINT
		do
			create random.make
			create Result.make (0, count-1)
			from i := 0
			until i > count-1
			loop
				create p.make_with_x_y (random.next(1,100), random.next(1,100))
				Result.put(p, i)
				i := i+1
			end
		end
end
